#define MATERIALFEATURES_FXH 1

// Features

#define MF_LIGHTING_AMBIENT uint2(0x1, 0)
#define MF_LIGHTING_PHONG uint2(0x2, 1)
#define MF_LIGHTING_PHONG_SPECULARMAP uint2(0x4, 2)
#define MF_LIGHTING_COOKTORRANCE uint2(0x8, 3)
#define MF_LIGHTING_COOKTORRANCE_SPECULARMAP uint2(0x10, 4)
#define MF_LIGHTING_COMPOSITE uint2(0x20, 5)
#define MF_LIGHTING_COMPOSITE_MAP uint2(0x40, 6)
#define MF_LIGHTING_FAKESSS uint2(0x80, 7)
#define MF_LIGHTING_FAKESSS_MAP uint2(0x100, 8)
#define MF_LIGHTING_FAKERIMLIGHT uint2(0x200, 9)
#define MF_LIGHTING_FAKERIMLIGHT_MAP uint2(0x400, 10)
#define MF_LIGHTING_MATCAP uint2(0x800, 11)
#define MF_LIGHTING_MATCAP_BLENDMAP uint2(0x1000, 12)
#define MF_LIGHTING_EMISSION uint2(0x2000, 13)
#define MF_LIGHTING_EMISSION_MAP uint2(0x4000, 14)
#define MF_LIGHTING_SHADOWS uint2(0x8000, 15)
#define MF_GI_SSAO uint2(0x10000, 16)
#define MF_GI_CSSGI uint2(0x20000, 17)
#define MF_GI_SSSSS uint2(0x40000, 18)
#define MF_GI_SSSSS_MAP uint2(0x80000, 19)
#define MF_REFLECTION_SPHEREMAP uint2(0x100000, 20)
#define MF_REFLECTION_SSLR uint2(0x200000, 21)
#define MF_REFLECTION_MAP uint2(0x400000, 22)
#define MF_REFRACTION_SPHEREMAP uint2(0x800000, 23)
#define MF_REFRACTION_SSLR uint2(0x1000000, 24)
#define MF_REFRACTION_MAP uint2(0x2000000, 25)
#define MF_CALCULATENORMALS uint2(0x4000000, 26)

// Parameters

#define MF_LIGHTING_AMBIENT_AMBIENTCOLOR_SIZE 3
#define MF_LIGHTING_AMBIENT_AMBIENTCOLOR 0
#define MF_LIGHTING_AMBIENT_ATTENUATION_SIZE 3
#define MF_LIGHTING_AMBIENT_ATTENUATION 3
#define MF_LIGHTING_PHONG_SPECULARCOLOR_SIZE 3
#define MF_LIGHTING_PHONG_SPECULARCOLOR 0
#define MF_LIGHTING_PHONG_SPECULARPOWER_SIZE 1
#define MF_LIGHTING_PHONG_SPECULARPOWER 3
#define MF_LIGHTING_PHONG_SPECULARSTRENGTH_SIZE 1
#define MF_LIGHTING_PHONG_SPECULARSTRENGTH 4
#define MF_LIGHTING_PHONG_ATTENUATION_SIZE 3
#define MF_LIGHTING_PHONG_ATTENUATION 5
#define MF_LIGHTING_PHONG_SPECULARMAP_MAPID_SIZE 1
#define MF_LIGHTING_PHONG_SPECULARMAP_MAPID 0
#define MF_LIGHTING_COOKTORRANCE_SPECULARCOLOR_SIZE 3
#define MF_LIGHTING_COOKTORRANCE_SPECULARCOLOR 0
#define MF_LIGHTING_COOKTORRANCE_SPECULARSTRENGTH_SIZE 1
#define MF_LIGHTING_COOKTORRANCE_SPECULARSTRENGTH 3
#define MF_LIGHTING_COOKTORRANCE_ROUGHNESS_SIZE 1
#define MF_LIGHTING_COOKTORRANCE_ROUGHNESS 4
#define MF_LIGHTING_COOKTORRANCE_REFLECTANCE_SIZE 1
#define MF_LIGHTING_COOKTORRANCE_REFLECTANCE 5
#define MF_LIGHTING_COOKTORRANCE_SPECULARMAP_MAPID_SIZE 1
#define MF_LIGHTING_COOKTORRANCE_SPECULARMAP_MAPID 0
#define MF_LIGHTING_COMPOSITE_AMBIENT_SIZE 1
#define MF_LIGHTING_COMPOSITE_AMBIENT 0
#define MF_LIGHTING_COMPOSITE_DIFFUSE_SIZE 1
#define MF_LIGHTING_COMPOSITE_DIFFUSE 1
#define MF_LIGHTING_COMPOSITE_SPECULAR_SIZE 1
#define MF_LIGHTING_COMPOSITE_SPECULAR 2
#define MF_LIGHTING_COMPOSITE_SPECMUL_SIZE 1
#define MF_LIGHTING_COMPOSITE_SPECMUL 3
#define MF_LIGHTING_COMPOSITE_SSS_SIZE 1
#define MF_LIGHTING_COMPOSITE_SSS 4
#define MF_LIGHTING_COMPOSITE_SSSMUL_SIZE 1
#define MF_LIGHTING_COMPOSITE_SSSMUL 5
#define MF_LIGHTING_COMPOSITE_RIM_SIZE 1
#define MF_LIGHTING_COMPOSITE_RIM 6
#define MF_LIGHTING_COMPOSITE_RIMMUL_SIZE 1
#define MF_LIGHTING_COMPOSITE_RIMMUL 7
#define MF_LIGHTING_COMPOSITE_MAP_MAPID_SIZE 1
#define MF_LIGHTING_COMPOSITE_MAP_MAPID 0
#define MF_LIGHTING_FAKESSS_STRENGTH_SIZE 1
#define MF_LIGHTING_FAKESSS_STRENGTH 0
#define MF_LIGHTING_FAKESSS_POWER_SIZE 1
#define MF_LIGHTING_FAKESSS_POWER 1
#define MF_LIGHTING_FAKESSS_THICKNESS_SIZE 1
#define MF_LIGHTING_FAKESSS_THICKNESS 2
#define MF_LIGHTING_FAKESSS_COEFFICIENT_SIZE 3
#define MF_LIGHTING_FAKESSS_COEFFICIENT 3
#define MF_LIGHTING_FAKESSS_ATTENUATION_SIZE 3
#define MF_LIGHTING_FAKESSS_ATTENUATION 6
#define MF_LIGHTING_FAKESSS_MAP_MAPID_SIZE 1
#define MF_LIGHTING_FAKESSS_MAP_MAPID 0
#define MF_LIGHTING_FAKERIMLIGHT_STRENGTH_SIZE 1
#define MF_LIGHTING_FAKERIMLIGHT_STRENGTH 0
#define MF_LIGHTING_FAKERIMLIGHT_POWER_SIZE 1
#define MF_LIGHTING_FAKERIMLIGHT_POWER 1
#define MF_LIGHTING_FAKERIMLIGHT_MAP_MAPID_SIZE 1
#define MF_LIGHTING_FAKERIMLIGHT_MAP_MAPID 0
#define MF_LIGHTING_MATCAP_MAPID_SIZE 1
#define MF_LIGHTING_MATCAP_MAPID 0
#define MF_LIGHTING_MATCAP_VIEWSPACE_SIZE 1
#define MF_LIGHTING_MATCAP_VIEWSPACE 1
#define MF_LIGHTING_MATCAP_TRANSFORM_SIZE 16
#define MF_LIGHTING_MATCAP_TRANSFORM 2
#define MF_LIGHTING_MATCAP_BLENDMAP_MAPID_SIZE 1
#define MF_LIGHTING_MATCAP_BLENDMAP_MAPID 0
#define MF_LIGHTING_EMISSION_COLOR_SIZE 3
#define MF_LIGHTING_EMISSION_COLOR 0
#define MF_LIGHTING_EMISSION_STRENGTH_SIZE 1
#define MF_LIGHTING_EMISSION_STRENGTH 3
#define MF_LIGHTING_EMISSION_MAP_MAPID_SIZE 1
#define MF_LIGHTING_EMISSION_MAP_MAPID 0
#define MF_LIGHTING_SHADOWS_BIAS_SIZE 1
#define MF_LIGHTING_SHADOWS_BIAS 0
#define MF_GI_SSAO_AMOUNTMUL_SIZE 1
#define MF_GI_SSAO_AMOUNTMUL 0
#define MF_GI_CSSGI_AMOUNTMUL_SIZE 1
#define MF_GI_CSSGI_AMOUNTMUL 0
#define MF_GI_CSSGI_RADIUSMUL_SIZE 1
#define MF_GI_CSSGI_RADIUSMUL 1
#define MF_GI_SSSSS_AMOUNTMUL_SIZE 1
#define MF_GI_SSSSS_AMOUNTMUL 0
#define MF_GI_SSSSS_RADIUSMUL_SIZE 1
#define MF_GI_SSSSS_RADIUSMUL 1
#define MF_GI_SSSSS_MAP_MAPID_SIZE 1
#define MF_GI_SSSSS_MAP_MAPID 0
#define MF_REFLECTION_SPHEREMAP_STRENGTH_SIZE 1
#define MF_REFLECTION_SPHEREMAP_STRENGTH 0
#define MF_REFLECTION_SPHEREMAP_FRESNEL_SIZE 2
#define MF_REFLECTION_SPHEREMAP_FRESNEL 1
#define MF_REFLECTION_SPHEREMAP_FRESNELPOWER_SIZE 2
#define MF_REFLECTION_SPHEREMAP_FRESNELPOWER 3
#define MF_REFLECTION_SPHEREMAP_BLUR_SIZE 1
#define MF_REFLECTION_SPHEREMAP_BLUR 5
#define MF_REFLECTION_SPHEREMAP_ENVID_SIZE 1
#define MF_REFLECTION_SPHEREMAP_ENVID 6
#define MF_REFLECTION_SPHEREMAP_MULTIPLY_SIZE 1
#define MF_REFLECTION_SPHEREMAP_MULTIPLY 7
#define MF_REFLECTION_SSLR_STRENGTH_SIZE 1
#define MF_REFLECTION_SSLR_STRENGTH 0
#define MF_REFLECTION_SSLR_FRESNEL_SIZE 1
#define MF_REFLECTION_SSLR_FRESNEL 1
#define MF_REFLECTION_SSLR_FRESNELPOWER_SIZE 1
#define MF_REFLECTION_SSLR_FRESNELPOWER 2
#define MF_REFLECTION_SSLR_BLUR_SIZE 1
#define MF_REFLECTION_SSLR_BLUR 3
#define MF_REFLECTION_SSLR_DISTANCE_SIZE 1
#define MF_REFLECTION_SSLR_DISTANCE 4
#define MF_REFLECTION_SSLR_MULTIPLY_SIZE 1
#define MF_REFLECTION_SSLR_MULTIPLY 5
#define MF_REFLECTION_MAP_AMOUNTMAPID_SIZE 1
#define MF_REFLECTION_MAP_AMOUNTMAPID 0
#define MF_REFLECTION_MAP_ROUGHNESSMAPID_SIZE 1
#define MF_REFLECTION_MAP_ROUGHNESSMAPID 1
#define MF_REFRACTION_SPHEREMAP_STRENGTH_SIZE 1
#define MF_REFRACTION_SPHEREMAP_STRENGTH 0
#define MF_REFRACTION_SPHEREMAP_IOR_SIZE 3
#define MF_REFRACTION_SPHEREMAP_IOR 1
#define MF_REFRACTION_SPHEREMAP_FRESNEL_SIZE 2
#define MF_REFRACTION_SPHEREMAP_FRESNEL 4
#define MF_REFRACTION_SPHEREMAP_FRESNELPOWER_SIZE 2
#define MF_REFRACTION_SPHEREMAP_FRESNELPOWER 6
#define MF_REFRACTION_SPHEREMAP_BLUR_SIZE 1
#define MF_REFRACTION_SPHEREMAP_BLUR 8
#define MF_REFRACTION_SPHEREMAP_ENVID_SIZE 1
#define MF_REFRACTION_SPHEREMAP_ENVID 9
#define MF_REFRACTION_SPHEREMAP_MULTIPLY_SIZE 1
#define MF_REFRACTION_SPHEREMAP_MULTIPLY 10
#define MF_REFRACTION_SSLR_STRENGTH_SIZE 1
#define MF_REFRACTION_SSLR_STRENGTH 0
#define MF_REFRACTION_SSLR_FRESNEL_SIZE 1
#define MF_REFRACTION_SSLR_FRESNEL 1
#define MF_REFRACTION_SSLR_FRESNELPOWER_SIZE 1
#define MF_REFRACTION_SSLR_FRESNELPOWER 2
#define MF_REFRACTION_SSLR_BLUR_SIZE 1
#define MF_REFRACTION_SSLR_BLUR 3
#define MF_REFRACTION_SSLR_DISTANCE_SIZE 1
#define MF_REFRACTION_SSLR_DISTANCE 4
#define MF_REFRACTION_SSLR_MULTIPLY_SIZE 1
#define MF_REFRACTION_SSLR_MULTIPLY 5
#define MF_REFRACTION_MAP_AMOUNTMAPID_SIZE 1
#define MF_REFRACTION_MAP_AMOUNTMAPID 0
#define MF_REFRACTION_MAP_ROUGHNESSMAPID_SIZE 1
#define MF_REFRACTION_MAP_ROUGHNESSMAPID 1
#define MF_CALCULATENORMALS_BLEND_SIZE 1
#define MF_CALCULATENORMALS_BLEND 0